package com.hncy.auth.inject.spring.boot.starter.config;

import com.hncy.auth.inject.spring.boot.starter.auth.AuthUser;
import com.hncy.auth.inject.spring.boot.starter.common.extractor.AuthInfoExtractor;
import com.hncy.auth.inject.spring.boot.starter.common.extractor.DefaultAuthInfoExtractor;
import com.hncy.auth.inject.spring.boot.starter.mvc.AuthUserInjectorResolver;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.web.servlet.DispatcherServletAutoConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.servlet.DispatcherServlet;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import java.util.List;

/**
 * @Author: ying.dong
 * @Date: 2021/4/25 17:38
 */
@Configuration
@ConditionalOnClass({WebMvcConfigurer.class, DispatcherServlet.class})
public class WebMvcConfiguration {

    @Configuration
    @AutoConfigureAfter(DispatcherServletAutoConfiguration.class)
    static class WebMvcAuthInjectConfiguration implements WebMvcConfigurer {

        @Autowired
        AuthInfoExtractor<AuthUser> authUserAuthInfoExtractor;

        @Override
        public void addArgumentResolvers(List<HandlerMethodArgumentResolver> resolvers) {
            resolvers.add(new AuthUserInjectorResolver(authUserAuthInfoExtractor));
        }
    }
}
