package com.hncy.auth.inject.spring.boot.starter.holder;

import com.hncy.auth.inject.spring.boot.starter.auth.AuthUser;
import com.hncy.auth.inject.spring.boot.starter.auth.DoctorAuthUser;
import com.hncy.auth.inject.spring.boot.starter.common.extractor.AuthInfoExtractor;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.lang.Nullable;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

/**
 * @Author: ying.dong
 * @Date: 2021/4/23 14:16
 */
public class AuthUserHolder {

    private final AuthInfoExtractor<AuthUser> extractor;

    public AuthUserHolder(AuthInfoExtractor<AuthUser> extractor) {
        this.extractor = extractor;
    }

    public AuthUser getAuthUser(HttpServletRequest request) {
        return extractor.extract(request).orElse(null);
    }

    @Nullable
    public AuthUser getAuthUser() {
        return extractor.extract().orElse(null);
    }

}
