package com.hncy.auth.inject.spring.boot.starter.util;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.Optional;

/**
 * @Author: ying.dong
 * @Date: 2021/7/17 14:06
 */
@Slf4j
public class RequestUtil {

    /**
     * 获取请求
     * @return
     */
    public static Optional<HttpServletRequest> getRequest() {
        Optional<HttpServletRequest> request = Optional.ofNullable(RequestContextHolder.getRequestAttributes())
                .map(it -> (ServletRequestAttributes) it)
                .map(ServletRequestAttributes::getRequest);
        if (!request.isPresent()) {
            log.info("request info not found.");
        }
        return request;
    }
}
