package com.hncy.exception.handler.spring.boot.starter.common;

import lombok.extern.slf4j.Slf4j;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:25
 */
@Slf4j
public class AlarmEventPublisher implements ApplicationEventPublisherAware {

    private static ApplicationEventPublisher applicationEventPublisher;

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher eventPublisher) {
        applicationEventPublisher = eventPublisher;
    }

    public static boolean publish(AlarmEvent event) {
        if (applicationEventPublisher == null) {
            log.debug("alarm event publisher maybe haven't initialed. ignored...");
            return false;
        }
        try {
            applicationEventPublisher.publishEvent(event);
        } catch (Exception e) {
            log.error("publish alarm event error.", e);
            return false;
        }
        return true;
    }
}
