package com.hncy.exception.handler.spring.boot.starter.core.translator.translators;

import com.hncy.common.exception.custom.LocalBusinessException;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class LocalBusinessExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        LocalBusinessException e = (LocalBusinessException) throwable;
        return ApiResultBuilder.build(e.getCode(), e.getMessage(), HttpStatus.INTERNAL_SERVER_ERROR);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof LocalBusinessException;
    }
}
