package com.hncy.exception.handler.spring.boot.starter.core.translator.translators;

import com.hncy.common.exception.common.GlobalErrorConstants;
import com.hncy.exception.handler.spring.boot.starter.common.*;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
public class UnsupportedExceptionTranslator extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        AlarmEventPublisher.publish(new AlarmEvent(throwable));
        return ApiResultBuilder.build(GlobalErrorConstants.INTERNAL_SERVER_ERROR.getCode(), GlobalErrorConstants.INTERNAL_SERVER_ERROR.getMessage(), HttpStatus.INTERNAL_SERVER_ERROR);
    }

    @Override
    public boolean support(Throwable throwable) {
        return true;
    }
}
