package com.hncy.exception.handler.spring.boot.starter.core.translator.translators.webmvc;

import com.hncy.common.exception.common.GlobalErrorConstants;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResult;
import com.hncy.exception.handler.spring.boot.starter.common.ApiResultBuilder;
import com.hncy.exception.handler.spring.boot.starter.core.translator.base.AbstractExceptionTranslator;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.ServletRequestBindingException;

/**
 * @Author: ying.dong
 * @Date: 2021/4/20 09:30
 */
public class ServletRequestBindingExceptionTranslator  extends AbstractExceptionTranslator {

    @Override
    protected ApiResult doTranslate(Throwable throwable) {
        return ApiResultBuilder.build(GlobalErrorConstants.BAD_REQUEST.getCode(), throwable.getMessage(), HttpStatus.BAD_REQUEST);
    }

    @Override
    public boolean support(Throwable throwable) {
        return throwable instanceof ServletRequestBindingException;
    }
}
