package com.hncy.exception.handler.spring.boot.starter.handler;

import com.hncy.exception.handler.spring.boot.starter.common.AlarmEvent;
import com.hncy.exception.handler.spring.boot.starter.core.alarm.AlarmReporter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.ApplicationListener;

import java.util.Optional;

/**
 * @Author: ying.dong
 * @Date: 2021/4/19 16:24
 */
@Slf4j
public class AlarmEventListener implements ApplicationListener<AlarmEvent> {

    private final AlarmReporter alarmReporter;

    public AlarmEventListener(AlarmReporter alarmReporter) {
        this.alarmReporter = alarmReporter;
    }

    @Override
    public void onApplicationEvent(AlarmEvent event) {
        if (alarmReporter == null) {
            log.warn("alarm reporter haven't been configured. ignore report...");
            return;
        }
        Optional.ofNullable(event.getSource())
                .ifPresent(alarmReporter::report);
    }
}
