package com.hncy.feign.spring.boot.starter.exception;

import com.hncy.exception.handler.spring.boot.starter.core.translator.ExceptionTranslatorRegistry;
import com.hncy.feign.spring.boot.starter.decoder.DefaultErrorDecoder;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Author: ying.dong
 * @Date: 2021/6/11 14:42
 */
@Configuration
public class FeignExceptionConfiguration {

    @Bean
    DefaultErrorDecoder defaultErrorDecoder() {
        return new DefaultErrorDecoder();
    }

    @Configuration
    @ConditionalOnClass(ExceptionTranslatorRegistry.class)
    static class RPCExceptionConfiguration {

        @Bean
        RPCExceptionTranslator rpcExceptionTranslator() {
            return new RPCExceptionTranslator();
        }
    }
}
