package com.hncy.file.manage.spring.boot.starter.core.manager;

import com.hncy.file.manage.spring.boot.starter.core.exception.ResourceException;
import com.hncy.file.manage.spring.boot.starter.core.resource.IResource;

/**
 * @Author: ying.dong
 * @Date: 2021/5/24 15:12
 */
public interface ResourceManager<T extends IResource> {

    /**
     * 获取资源
     * @param role
     * @param resource
     * @return
     */
    T get(String role, T resource) throws ResourceException;

    /**
     * 新增或者更新资源
     * @param role
     * @param resource
     * @param allowOverride
     * @return
     */
    T save(String role, T resource, boolean allowOverride) throws ResourceException;

    /**
     * 删除资源(URL)
     * @param role
     * @param resource
     * @return
     */
//    T delSign(String role, T resource) throws ResourceException;

    /**
     * 直接删除资源
     * @param role
     * @param resource
     * @return
     * @throws ResourceException
     */
    boolean del(String role, T resource) throws ResourceException;
}
