package com.hncy.file.manage.spring.boot.starter.oss.common;

import com.aliyun.oss.ClientBuilderConfiguration;
import com.aliyun.oss.OSS;
import com.aliyun.oss.common.auth.DefaultCredentialProvider;
import com.aliyun.oss.common.comm.ServiceClient;
import com.hncy.file.manage.spring.boot.starter.core.common.Factory;
import com.hncy.file.manage.spring.boot.starter.oss.properties.OSSRoleProperties;
import com.hncy.file.manage.spring.boot.starter.oss.sdk.BugFixedOSSClient;
import com.hncy.file.manage.spring.boot.starter.oss.sdk.BugFixedServiceClient;

/**
 * @Author: ying.dong
 * @Date: 2021/5/24 18:31
 */
public class OSSClientFactory implements Factory<OSSClient, OSSRoleProperties> {

    @Override
    public OSSClient getObject(OSSRoleProperties ossRoleProperties) {
        ClientBuilderConfiguration configuration = new ClientBuilderConfiguration();
        configuration.setSLDEnabled(ossRoleProperties.isOwnDomain());
        DefaultCredentialProvider defaultCredentialProvider = new DefaultCredentialProvider(ossRoleProperties.getAccessKey(), ossRoleProperties.getAccessSecret());
        ServiceClient serviceClient = new BugFixedServiceClient(configuration, ossRoleProperties.getBucket());
        OSS sdkClient = new BugFixedOSSClient(ossRoleProperties.getEndpoint(), defaultCredentialProvider,configuration, serviceClient);
        return new DefaultOSSClient(ossRoleProperties, sdkClient);
    }
}
