package com.hncy.file.manage.spring.boot.starter.oss.manager;

import cn.hutool.core.util.URLUtil;
import com.hncy.file.manage.spring.boot.starter.core.exception.ResourceException;
import com.hncy.file.manage.spring.boot.starter.oss.common.OSSClient;
import com.hncy.file.manage.spring.boot.starter.oss.common.OSSClientRegistry;
import com.hncy.file.manage.spring.boot.starter.oss.properties.OSSRoleProperties;
import com.hncy.file.manage.spring.boot.starter.oss.resource.OSSResource;

import java.net.MalformedURLException;
import java.net.URL;

/**
 * 适用于公共Bucket (公开读，私有写)
 * @Author: ying.dong
 * @Date: 2021/8/23 14:58
 */
public class OSSPubBucketManager extends OSSSignedManager {

    public OSSPubBucketManager(OSSClientRegistry ossClientRegistry) {
        super(ossClientRegistry);
    }

    @Override
    public OSSResource get(String role, OSSResource resource) throws ResourceException {
        OSSClient ossClient = getOSSClient(role);
        OSSRoleProperties configuration = ossClient.getConfiguration();
        String key = getFileName(configuration, resource);
        String urlStr = configuration.getEndpoint() + "/" + key;
        try {
            URL url = new URL(URLUtil.normalize(urlStr));
            resource.setUrl(url);
        } catch (MalformedURLException e) {
            throw new RuntimeException(e);
        }
        return resource;
    }
}
