package com.hncy.lock.spring.boot.starter.config;

import com.hncy.lock.spring.boot.starter.core.Lock;
import com.hncy.lock.spring.boot.starter.distribute.DLock;
import com.hncy.lock.spring.boot.starter.distribute.ReentrantRedisLock;
import com.hncy.redis.spring.boot.starter.core.RedisRepository;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Author: ying.dong
 * @Date: 2021/5/28 15:12
 */
@Configuration
public class DistributionLockConfiguration {

    @Configuration
    @ConditionalOnClass(RedisRepository.class)
    static class RedisLockConfiguration {

        @Bean
        @ConditionalOnMissingBean(DLock.class)
        Lock redisLock(RedisRepository<String> redisRepository) {
            return new ReentrantRedisLock(redisRepository);
        }
    }
}
