package com.hncy.mybatis.spring.boot.starter.base;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
@MappedSuperclass
@Data
public class BaseScaleEntity implements Serializable {
    private static final long serialVersionUID = -8268645569511804123L;
    @Id
    @Column(name = "id",length = 64)
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private String id;

    /**
     * 修改时间
     */

    @Column(name = "gmt_modified")
    @Temporal(TemporalType.TIMESTAMP)
    @TableField(value = "gmt_modified",fill = FieldFill.INSERT_UPDATE)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss", iso = DateTimeFormat.ISO.DATE_TIME)
    private Date gmtModified;

    /***
     * 创建时间
     */
    @Column(name = "gmt_create")
    @Temporal(TemporalType.TIMESTAMP)
    @TableField(value = "gmt_create",fill = FieldFill.INSERT)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss", iso = DateTimeFormat.ISO.DATE_TIME)
    private Date gmtCreate;

    /**
     * 创建者
     */

    @Column(name = "create_by",length = 50,updatable = false)
    @TableField(value = "create_by",fill = FieldFill.INSERT)
    private String createBy;


    /**
     * 更新者
     */

    @Column(name = "update_by",length = 50)
    @TableField(value = "update_by",fill = FieldFill.INSERT_UPDATE)
    private String updateBy;

    public static final String ID = "id";
    public static final String GMT_MODIFIED = "gmt_modified";
    public static final String GMT_CREATE = "gmt_create";
    public static final String DELETED_FLAG = "deleted_flag";
    public static final String CREATE_BY = "create_by";
}
