package com.hncy.mybatis.spring.boot.starter.handler;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.hncy.auth.inject.spring.boot.starter.auth.AuthUser;
import com.hncy.auth.inject.spring.boot.starter.holder.AuthUserHolder;
import com.hncy.mybatis.spring.boot.starter.base.BaseEntity;
import com.hncy.mybatis.spring.boot.starter.base.BaseScaleEntity;
import org.apache.ibatis.reflection.MetaObject;

import java.util.Date;
import java.util.Optional;

/**
 * @author xuy
 * @date 19/08/2020.
 */
public class MetaHandler implements MetaObjectHandler  {

    private final AuthUserHolder authUserHolder;

    public MetaHandler(AuthUserHolder authUserHolder) {
        this.authUserHolder = authUserHolder;
    }

    @Override
    public void insertFill(MetaObject metaObject) {
        if(!(metaObject.getOriginalObject() instanceof BaseEntity||metaObject.getOriginalObject() instanceof BaseScaleEntity)){
            return;
        }
        String operatorUser = getAcc();
        this.setFieldValByName("gmtCreate",new Date(),metaObject);
        this.setFieldValByName("gmtModified", new Date(), metaObject);
        this.setFieldValByName("createBy", operatorUser,metaObject);
        this.setFieldValByName("updateBy", operatorUser, metaObject);
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        if(!(metaObject.getOriginalObject() instanceof BaseEntity||metaObject.getOriginalObject() instanceof BaseScaleEntity)){
            return;
        }
        String operatorUser = getAcc();
        this.setFieldValByName("gmtModified", new Date(), metaObject);
        this.setFieldValByName("updateBy", operatorUser, metaObject);
    }

    private String getAcc() {
        return Optional.ofNullable(authUserHolder.getAuthUser())
                .map(AuthUser::getAccount)
                .orElse("anymoreUser");
    }
}
