package com.hncy.notifier.spring.boot.starter.config;

import com.hncy.notifier.spring.boot.starter.core.Notifier;
import com.hncy.notifier.spring.boot.starter.mail.AbstractMailNotifier;
import com.hncy.notifier.spring.boot.starter.mail.MailProperties;
import com.hncy.notifier.spring.boot.starter.mail.SimpleMailNotifier;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.mail.MailSender;
import org.springframework.mail.javamail.JavaMailSender;

/**
 * @Author: ying.dong
 * @Date: 2021/8/6 16:32
 */
@EnableConfigurationProperties(MailProperties.class)
@ConditionalOnProperty(prefix = MailProperties.PREFIX, name = "enabled",
        havingValue = "true", matchIfMissing = true)
public class MailNotifierConfiguration {

    @Bean(name = "emailNotifier")
    @ConditionalOnBean(MailSender.class)
    @ConditionalOnMissingBean(AbstractMailNotifier.class)
    public Notifier notifier(JavaMailSender javaMailSender, MailProperties mailProperties) {
        return new SimpleMailNotifier(javaMailSender, mailProperties);
    }
}
