package com.hncy.notifier.spring.boot.starter.mail;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.cloud.context.config.annotation.RefreshScope;

/**
 * @Author: ying.dong
 * @Date: 2021/8/6 15:45
 */
@Data
@RefreshScope
@ConfigurationProperties(prefix = MailProperties.PREFIX)
public class MailProperties {

    public static final String PREFIX = "config.notify.mail";

    private boolean enabled = true;

    /**
     * 标题
     */
    private String subject;

    /**
     * 发送方
     */
    private String from;

    /**
     * 接收方
     */
    private String[] to = {};

    /**
     * 抄送
     */
    private String[] cc = {};
}
