package com.hncy.pageable.spring.boot.starter.config;

import com.baomidou.mybatisplus.autoconfigure.MybatisPlusAutoConfiguration;
import com.github.pagehelper.PageInterceptor;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;


import javax.annotation.PostConstruct;
import java.util.List;

/**
 * @Author: ying.dong
 * @Date: 2021/5/7 13:46
 */
@Configuration
@ConditionalOnClass({SqlSessionFactory.class, MybatisPlusAutoConfiguration.class})
public class MybatisInterceptorConfiguration {

    @Bean
    @ConditionalOnMissingBean
    PageInterceptor pageInterceptor() {
        return new PageInterceptor();
    }

}
