package com.hncy.sms.spring.boot.starter.aliyun.config;

import com.hncy.sms.spring.boot.starter.aliyun.AliyunSmsManager;
import com.hncy.sms.spring.boot.starter.aliyun.client.AliyunSmsClient;
import com.hncy.sms.spring.boot.starter.aliyun.util.AliyunSmsProperties;
import com.hncy.sms.spring.boot.starter.constant.SmsConstant;
import com.hncy.sms.spring.boot.starter.core.SmsManager;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Author: ying.dong
 * @Date: 2021/5/11 19:40
 */
@Configuration
@ConditionalOnProperty(
        value = {SmsConstant.Enabled.ALIYUN},
        havingValue = "true",
        matchIfMissing = true
)
@EnableConfigurationProperties(AliyunSmsProperties.class)
@EnableFeignClients("com.hncy.sms.spring.boot.starter.aliyun.client")
public class AliyunSmsConfiguration {

    @Bean
    SmsManager aliyunSmsManager(AliyunSmsProperties properties, AliyunSmsClient aliyunSmsClient) {
        return new AliyunSmsManager(properties, aliyunSmsClient);
    }
}
