package com.hncy.sms.spring.boot.starter.core;

import com.hncy.sms.spring.boot.starter.core.exception.SmsException;
import com.hncy.sms.spring.boot.starter.core.request.BatchSmsRequest;
import com.hncy.sms.spring.boot.starter.core.request.SingleSmsRequest;
import com.hncy.sms.spring.boot.starter.core.response.SmsResponse;

/**
 * @Author: ying.dong
 * @Date: 2021/5/11 14:02
 */
public interface SmsManager {

    /**
     * 发送单条短信
     * @param request
     * @return
     * @throws Exception
     */
    SmsResponse send(SingleSmsRequest request) throws SmsException;

    /**
     * 批量短信
     * @param request
     * @return
     * @throws Exception
     */
    SmsResponse batchSend(BatchSmsRequest request) throws SmsException;
}
