package com.hncy.common.cache;

import com.hncy.common.cache.store.ObjectStore;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Optional;

/**
 * @Author: ying.dong
 * @Date: 2021/10/13 10:49
 */
public abstract class BaseCachingObjectManager<K, V> implements CachingObjectManager<K, V> {

    protected final Logger logger = LoggerFactory.getLogger(getClass());

    protected final ObjectStore<K, V> objectStore;

    protected BaseCachingObjectManager(ObjectStore<K, V> objectStore) {
        this.objectStore = objectStore;
    }

    @Override
    public boolean save(K k, V v) {
        return objectStore.save(k, v);
    }

    @Override
    public Optional<V> getObject(K k) {
        return Optional.ofNullable(objectStore.getObject(k));
    }

    @Override
    public boolean remove(K k) {
        return objectStore.remove(k);
    }
}
