package com.hncy.common.exception.custom;

import com.hncy.common.exception.common.ErrorCode;
import com.hncy.common.exception.common.GlobalErrorConstants;

/**
 * @Author: ying.dong
 * @Date: 2021/4/20 18:22
 */
public class BusinessException extends BaseBusinessException {

    private static final long serialVersionUID = -9040723087491516359L;
    private int code;
    private String message;

    public BusinessException() {
        this(GlobalErrorConstants.INTERNAL_SERVER_ERROR);
    }

    public BusinessException(ErrorCode errorCode) {
        this(errorCode.getCode(), errorCode.getMessage());
    }

    public BusinessException(int code, String message) {
        super(message);
        this.code = code;
    }

    public BusinessException(String message) {
        super(message);
        this.code = GlobalErrorConstants.INTERNAL_SERVER_ERROR.getCode();
    }

    public BusinessException(Throwable throwable) {
        super(throwable);
        this.code = GlobalErrorConstants.INTERNAL_SERVER_ERROR.getCode();
    }

    public void setCode(int code) {
        this.code = code;
    }
    public void setMessage(String message) {
        this.message = message;
    }

    public int getCode() {
        return code;
    }
}
