package com.hncy.service.wechat.applet.api.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 微信小程序用户表
 * </p>
 *
 * @author hncy
 * @since 2021-04-14
 */
@Data
//@EqualsAndHashCode(callSuper = true)
@ApiModel(value="WxUser对象", description="微信小程序用户表")
@AllArgsConstructor
@NoArgsConstructor
public class WxUserVo implements Serializable{

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "微信小程序用户id")
    private String id;

    @ApiModelProperty(value = "微信对应小程序唯一识别号")
    private String openId;

    @ApiModelProperty(value = "用户在开放平台的唯一标识符")
    private String unionid;

    @ApiModelProperty(value = "头像相对路径")
    private String avatar;

    @ApiModelProperty(value = "昵称")
    private String nickname;

    @ApiModelProperty(value = "1：男，2：女")
    private String sexCode;

    @ApiModelProperty(value = "男，女")
    private String sexName;

    @ApiModelProperty(value = "手机号")
    private String tel;

    @ApiModelProperty(value = "删除状态，0：未删除，1：已删除")
    private String deleted;

    @ApiModelProperty(value = "最近登录时间")
    private LocalDateTime loginDate;

    private LocalDateTime gmtCreate;

    public static final String ID = "id";

    public static final String OPEN_ID = "open_id";

    public static final String AVATAR = "avatar";

    public static final String NICKNAME = "nickname";

    public static final String SEX_CODE = "sex_code";

    public static final String SEX_NAME = "sex_name";

    public static final String TEL = "tel";

    public static final String DELETED = "deleted";

    public static final String LOGIN_DATE = "login_date";

    public static final String GMT_CREATE = "gmt_create";

}
