package com.hncy.service.wechat.applet.biz;

import com.hncy.service.wechat.applet.api.constant.ServiceWxAppletApiConstant;
import com.hncy.service.wechat.applet.biz.mini.constant.MiniProgramConstant;
import lombok.extern.slf4j.Slf4j;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.cloud.openfeign.EnableFeignClients;

/**
 * @Author: cs
 * @Date: 2021/10/27 13:43
 */
@SpringBootApplication
@Slf4j
@MapperScan("com.hncy.service.wechat.applet.biz.mapper")
@EnableConfigurationProperties
@EnableCaching
@EnableFeignClients(basePackages = {
        MiniProgramConstant.CLIENT_PACKAGE,
        ServiceWxAppletApiConstant.FEIGN_BASE_PACKAGE})
public class ArxjWxAppletApplication {

    public static void main(String[] args) {
        SpringApplication.run(ArxjWxAppletApplication.class, args);
    }
}
