package com.hncy.service.wechat.applet.biz.controller;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.hncy.service.wechat.applet.biz.entity.CommunityGrid;
import com.hncy.service.wechat.applet.biz.service.CommunityGridService;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;
import java.util.List;

import org.springframework.web.bind.annotation.RestController;

/**
* <p>
    * 社区网格controller
    * </p>
*
* @author cs
* @since 2021-11-29
*/
@RestController
@RequestMapping("/community-grid")
@Slf4j
@Api(tags = "社区网格")
public class CommunityGridController {

    @Autowired
    private CommunityGridService communityGridService;

    @ApiOperation(value = "查询分页数据")
    @PostMapping(value = "/pagelist",produces = "application/json;charset=UTF-8")
    public ResultBean findListByPage(@ApiParam(name = "pageNum", value = "页码", required = true, defaultValue = "1")@RequestParam(name = "pageNum", defaultValue = "1") int pageNum,
                                     @ApiParam(name = "pageSize", value = "每页条数", required = true, defaultValue = "10")@RequestParam(name = "pageSize", defaultValue = "10") int pageSize){
           return null;
    }

    @ApiOperation(value = "根据id查询数据")
    @GetMapping(value = "/getById",produces = "application/json;charset=UTF-8")
    public ResultBean<CommunityGrid> getById(@ApiParam(name = "id", value = "id", required = true)@RequestParam("id") String id){
        CommunityGrid communityGrid = communityGridService.getById(id);
        return ResultBean.success(communityGrid);
    }

    @ApiOperation(value = "新增/修改数据")
    @PostMapping(value = "/saveAndUpdate", produces = "application/json;charset=UTF-8")
    public ResultBean<Void> saveAndUpdate(@ApiParam(name = "communityGrid", value = "CommunityGrid", required = true)@RequestBody CommunityGrid communityGrid){
        communityGridService.saveOrUpdate(communityGrid);
        return ResultBean.success();
    }

    @ApiOperation(value = "删除数据")
    @DeleteMapping(value = "/delByIds")
    public ResultBean<Void> delete(@ApiParam(name = "ids", value = "ID集合", required = true)@RequestParam("ids") List<String> ids){
        communityGridService.removeByIds(ids);
        return ResultBean.success();
    }
}
