package com.hncy.service.wechat.applet.biz.controller;

import com.hncy.repeatable.check.spring.boot.starter.interfaceann.RepeatableInterface;
import com.hncy.service.wechat.applet.biz.dto.ComponentPictureDto;
import com.hncy.service.wechat.applet.biz.entity.ComponentDetail;
import com.hncy.service.wechat.applet.biz.vo.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.hncy.service.wechat.applet.biz.service.ComponentDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;

import java.time.LocalDateTime;
import java.util.List;

import org.springframework.web.bind.annotation.RestController;

/**
* <p>
    * 部件详情controller
    * </p>
*
* @author cs
* @since 2021-11-02
*/
@RestController
@RequestMapping("/component-detail")
@Slf4j
@Api(tags = "部件详情")
public class ComponentDetailController {

    @Autowired
    private ComponentDetailService componentDetailService;

/*    @ApiOperation(value = "获取城市系统的部件（内部调用）")
    @GetMapping(value = "/getComponentByCtiySys")
    ResultBean getComponentByCtiySys() {
        return componentDetailService.getComponentByCtiySys();
    }

    @ApiOperation(value = "获取城市部件类型以及立案条件（内部调用）")
    @GetMapping(value = "/getComponentTypeAndRegCondByCtiySys")
    ResultBean getComponentTypeAndRegCondByCtiySys() {
        return componentDetailService.getComponentTypeAndRegCondByCtiySys();
    }*/

    @ApiOperation(value = "判断AI扫描出的部件是否存在于后台数据库(只会扫描出该坐标点0.5米内的一个井盖)")
    @PostMapping(value = "/judgeAIComponentIsExist")
    ResultBean<ComponentAcquisitionVo> judgeAIComponentIsExist(@ApiParam(name = "componentTypeName",value = "部件类型名字",required = true)@RequestParam("componentTypeName") String componentTypeName,
                                                                                  @ApiParam(name = "xCode",value = "经度",required = true)@RequestParam("xCode") String xCode,
                                                                                  @ApiParam(name = "yCode",value = "纬度",required = true)@RequestParam("yCode") String yCode) {
        return componentDetailService.judgeAIComponentIsExist(componentTypeName,xCode,yCode);
    }

    @ApiOperation(value = "部件采集")
    @PostMapping(value = "/componentAcquisition")
    ResultBean componentAcquisition(@ApiParam(name = "componentName",value = "部件子类名字",required = true)@RequestParam("componentName") String componentName,
                                    @ApiParam(name = "componentCode",value = "部件子类编码",required = true)@RequestParam("componentCode") String componentCode,
                                    @ApiParam(name = "componentSuperName",value = "部件父类名称：市容环境，公用设施，拓展部件",required = true)@RequestParam("componentSuperName") String componentSuperName,
                                    @ApiParam(name = "componentSuperCode",value = "部件父类编码",required = true)@RequestParam("componentSuperCode") String componentSuperCode,
                                    @ApiParam(name = "componentTypeName",value = "部件类型名称：垃圾桶，井盖",required = true)@RequestParam("componentTypeName") String componentTypeName,
                                    @ApiParam(name = "componentTypeCode",value = "部件类型编码",required = true)@RequestParam("componentTypeCode") String componentTypeCode,
                                    @ApiParam(name = "componentAddress",value = "部件采集详细地址",required = true)@RequestParam("componentAddress") String componentAddress,
                                    @ApiParam(name = "xCode",value = "部件采集经度",required = true)@RequestParam("xCode") String xCode,
                                    @ApiParam(name = "yCode",value = "部件采集纬度",required = true)@RequestParam("yCode") String yCode,
                                    @ApiParam(name = "patrolInspectionTime",value = "巡检时间",required = true)@RequestParam("patrolInspectionTime")@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss") LocalDateTime patrolInspectionTime,
                                    @ApiParam(name = "regCondCode",value = "部件上报案件条件编码",required = true)@RequestParam("regCondCode") String regCondCode,
                                    @ApiParam(name = "regCondName",value = "部件上报案件条件名称",required = true)@RequestParam("regCondName") String regCondName,
                                    @ApiParam(name = "issueDescription",value = "部件上报案件描述情况",required = false)@RequestParam(value = "issueDescription",required = false) String issueDescription,
                                    @ApiParam(name = "pictureIds",value = "图片id组",required = true)@RequestParam("pictureIds") List<String> pictureIds,
                                    @ApiParam(name = "collectorNickName",value = "采集人员昵称",required = true)@RequestParam("collectorNickName") String collectorNickName,
                                    @ApiParam(name = "collectorOpenId",value = "采集人员微信openid",required = true)@RequestParam("collectorOpenId") String collectorOpenId,
                                    @ApiParam(name = "issueNumber",value = "上报问题单号(32位UUID,防止重复点击)",required = true)@RequestParam("issueNumber") String issueNumber) {

        return componentDetailService.componentAcquisition(componentName,componentCode,componentSuperName,componentSuperCode,componentTypeName,componentTypeCode,componentAddress,xCode,yCode,patrolInspectionTime,regCondCode,regCondName,issueDescription,pictureIds,collectorNickName,collectorOpenId,issueNumber);
    }

    @ApiOperation(value = "获取当前小程序用户下今日巡检数，部件采集总数，上报采集总数")
    @PostMapping(value = "/selectTodaySum")
    ResultBean<PatrolInspectionSumVo> selectTodaySum(@ApiParam(name = "collectorOpenId",value = "当前微信用户openid",required = true)@RequestParam("collectorOpenId") String collectorOpenId) {
        return componentDetailService.selectTodaySum(collectorOpenId);
    }

    @ApiOperation(value = "获取当前小程序用户下今日巡检部件的类别和每个类别下的总数")
    @PostMapping(value = "/selectTodayComponentsTypeSum")
    ResultBean<List<PatrolInspectionComponentsSumVo>> selectTodayComponentsTypeSum(@ApiParam(name = "collectorOpenId",value = "当前微信用户openid",required = true)@RequestParam("collectorOpenId") String collectorOpenId) {
        return componentDetailService.selectTodayComponentsTypeSum(collectorOpenId);
    }

    @ApiOperation(value = "添加巡检时间记录")
    @PostMapping(value = "/savepatrolInspectionTime")
    ResultBean savepatrolInspectionTime(@ApiParam(name = "patrolInspectionTime",value = "巡检时间",required = true)@RequestParam("patrolInspectionTime")@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss") LocalDateTime patrolInspectionTime,
                                        @ApiParam(name = "componentLogos",value = "部件标识组",required = true)@RequestParam("componentLogos") List<String> componentLogos) {
        return componentDetailService.savepatrolInspectionTime(patrolInspectionTime,componentLogos);
    }

    @ApiOperation(value = "查询当前区域下,过去半年内每个月的部件采集数量(拟态网格)")
    @PostMapping(value = "/selectSumComponentsByMounth")
    ResultBean<List<CountMonthComponentsVo>> selectSumComponentsByMounth(@ApiParam(name = "code",value = "区域编码,示例值(511402)",required = true)@RequestParam("code") String code,
                                                                         @ApiParam(name = "type",value = "区域类型:grid-网格;community-社区;street-街道;district-区域,示例值(district)",required = true)@RequestParam("type") String type) {
        return componentDetailService.selectSumComponentsByMounth(code,type);
    }

    @ApiOperation(value = "查询当前区域下今日每个父类下面的部件数及类型(拟态网格)")
    @PostMapping(value = "/selectTodayComponentsSuperTypeSum")
    ResultBean<List<PatrolInspectionComponentsSuperTypeSumVo>> selectTodayComponentsSuperTypeSum(@ApiParam(name = "code",value = "区域编码,示例值(511402)",required = true)@RequestParam("code") String code,
                                                                                                 @ApiParam(name = "type",value = "区域类型:grid-网格;community-社区;street-街道;district-区域,示例值(district)",required = true)@RequestParam("type") String type) {
        return componentDetailService.selectTodayComponentsSuperTypeSum(code,type);
    }

    @ApiOperation(value = "当前区域下，获取ar巡检的总数，部件的完好数，异常数(拟态网格)")
    @PostMapping(value = "/selectSumComponentsInDirection")
    ResultBean<CountComponentsVo> selectSumComponentsInDirection(@ApiParam(name = "code",value = "区域编码,示例值(511402)",required = true)@RequestParam("code") String code,
                                                                 @ApiParam(name = "type",value = "区域类型:grid-网格;community-社区;street-街道;district-区域,示例值(district)",required = true)@RequestParam("type") String type) {
        return componentDetailService.selectSumComponentsInDirection(code,type);
    }

    @ApiOperation(value = "查询当前区域下，根据部件类别获取该类别下的所有部件信息(拟态网格)")
    @PostMapping(value = "/selectDetailComponents")
    ResultBean<List<ComponentsSearchVo>> selectDetailComponents(@ApiParam(name = "code",value = "区域编码,示例值(511402)",required = true)@RequestParam("code") String code,
                                                             @ApiParam(name = "type",value = "区域类型:grid-网格;community-社区;street-街道;district-区域,示例值(district)",required = true)@RequestParam("type") String type,
                                                             @ApiParam(name = "componentName",value = "部件名称",required = true)@RequestParam("componentName") String componentName,
                                                             @ApiParam(name = "componentCode",value = "部件代码",required = true)@RequestParam("componentCode") String componentCode) {
        return componentDetailService.selectDetailComponents(code,type,componentCode,componentName);
    }

    @ApiOperation(value = "获取当前区域下今日巡检部件总数(拟态网格)")
    @PostMapping(value = "/selectTodaySumInDirection")
    ResultBean<PatrolInspectionSumVoInDirection> selectTodaySumInDirection(@ApiParam(name = "code",value = "区域编码,示例值(511402)",required = true)@RequestParam("code") String code,
                                                                           @ApiParam(name = "type",value = "区域类型:grid-网格;community-社区;street-街道;district-区域,示例值(district)",required = true)@RequestParam("type") String type) {
        return componentDetailService.selectTodaySumInDirection(code,type);
    }


}
