package com.hncy.service.wechat.applet.biz.controller;

import cn.hutool.core.date.DateTime;
import com.hncy.repeatable.check.spring.boot.starter.interfaceann.RepeatableInterface;
import com.hncy.service.wechat.applet.biz.vo.ComponentSubTypesVo;
import com.hncy.service.wechat.applet.biz.vo.RegTypesVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.hncy.service.wechat.applet.biz.entity.ComponentIssuesReport;
import com.hncy.service.wechat.applet.biz.service.ComponentIssuesReportService;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;

import java.time.LocalDateTime;
import java.util.List;

import org.springframework.web.bind.annotation.RestController;

/**
* <p>
    * 部件问题上报controller
    * </p>
*
* @author cs
* @since 2021-11-02
*/
@RestController
@RequestMapping("/component-issues-report")
@Slf4j
@Api(tags = "部件问题上报")
public class ComponentIssuesReportController {

    @Autowired
    private ComponentIssuesReportService componentIssuesReportService;


    @ApiOperation(value = "根据上报部件名称和code获取所有部件上报案件状态类型")
    @PostMapping(value = "/selectAllRegTypesByCodeAndName")
    ResultBean<List<RegTypesVo>> selectAllRegTypesByCodeAndName(@ApiParam(name = "componentReportCode",value = "上报部件代码",required = false) @RequestParam(value = "componentReportCode",required = false) String componentReportCode,
                                                                @ApiParam(name = "componentReportName",value = "上报部件名称",required = false) @RequestParam(value = "componentReportName",required = false) String componentReportName) {
        return componentIssuesReportService.selectAllRegTypes(componentReportCode,componentReportName);
    }

    @ApiOperation(value = "新增上报问题部件")
    @PostMapping(value = "/saveComponentIssues")
    ResultBean saveComponentIssues(@ApiParam(name = "regCondCode",value = "部件上报案件条件编码",required = true) @RequestParam("regCondCode") String regCondCode,
                                   @ApiParam(name = "regCondName",value = "部件上报案件条件名称",required = true) @RequestParam("regCondName") String regCondName,
                                   @ApiParam(name = "issueDescription",value = "部件上报案件描述情况",required = true) @RequestParam("issueDescription") String issueDescription,
                                   @ApiParam(name = "componentReportCode",value = "上报部件代码",required = true) @RequestParam("componentReportCode") String componentReportCode,
                                   @ApiParam(name = "componentReportName",value = "上报部件名称",required = true) @RequestParam("componentReportName") String componentReportName) {
        return componentIssuesReportService.saveComponentIssues(regCondCode,regCondName,issueDescription,componentReportCode,componentReportName);
    }

    @ApiOperation(value = "问题上报")
    @PostMapping(value = "/componentReport")
    ResultBean componentReport(@ApiParam(name = "componentName",value = "部件子类名字",required = true)@RequestParam("componentName") String componentName,
                               @ApiParam(name = "componentCode",value = "部件子类编码",required = true)@RequestParam("componentCode") String componentCode,
                               @ApiParam(name = "componentSuperName",value = "部件父类名称：市容环境，公用设施，拓展部件",required = true)@RequestParam("componentSuperName") String componentSuperName,
                               @ApiParam(name = "componentSuperCode",value = "部件父类编码",required = true)@RequestParam("componentSuperCode") String componentSuperCode,
                               @ApiParam(name = "componentAddress",value = "问题上报人的详细地址",required = true)@RequestParam("componentAddress") String componentAddress,
                               @ApiParam(name = "xCode",value = "当前上报经度",required = true)@RequestParam("xCode") String xCode,
                               @ApiParam(name = "yCode",value = "当前上报纬度",required = true)@RequestParam("yCode") String yCode,
                               @ApiParam(name = "reportTime",value = "上报时间",required = true)@RequestParam("reportTime")@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss") DateTime reportTime,
                               @ApiParam(name = "regCondCode",value = "部件上报案件条件编码",required = true)@RequestParam("regCondCode") String regCondCode,
                               @ApiParam(name = "regCondName",value = "部件上报案件条件名称",required = true)@RequestParam("regCondName") String regCondName,
                               @ApiParam(name = "issueDescription",value = "部件上报案件描述情况",required = true)@RequestParam(value = "issueDescription",required = false) String issueDescription,
                               @ApiParam(name = "pictureIds",value = "当前上报图片id组",required = true)@RequestParam("pictureIds") List<String> pictureIds,
                               @ApiParam(name = "reportNickName",value = "上报人员昵称",required = true)@RequestParam("reportNickName") String reportNickName,
                               @ApiParam(name = "componentLogos",value = "部件标识组",required = true)@RequestParam("componentLogos") List<String> componentLogos,
                               @ApiParam(name = "reportOpenId",value = "上报人员微信openId",required = true)@RequestParam("reportOpenId") String reportOpenId,
                               @ApiParam(name = "issueNumber",value = "上报问题单号(32位UUID,防止重复点击)",required = true)@RequestParam("issueNumber") String issueNumber) {
        return componentIssuesReportService.componentReport(componentName,componentCode,componentSuperName,componentSuperCode,componentAddress,xCode,yCode,reportTime,regCondCode,regCondName,issueDescription,pictureIds,reportNickName,componentLogos,reportOpenId,issueNumber);
    }

}
