package com.hncy.service.wechat.applet.biz.controller;

import cn.hutool.core.date.DateTime;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.hncy.common.exception.custom.BusinessException;
import com.hncy.pageable.spring.boot.starter.core.Page;
import com.hncy.repeatable.check.spring.boot.starter.interfaceann.RepeatableInterface;
import com.hncy.service.wechat.applet.biz.entity.ComponentDetail;
import com.hncy.service.wechat.applet.biz.service.ComponentDetailService;
import com.hncy.service.wechat.applet.biz.vo.AuditComponentVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import com.hncy.common.dto.ResultBean;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.hncy.service.wechat.applet.biz.entity.PlatformAudit;
import com.hncy.service.wechat.applet.biz.service.PlatformAuditService;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.Api;
import java.util.List;

import org.springframework.web.bind.annotation.RestController;

/**
* <p>
    * 平台端审核表controller
    * </p>
*
* @author cs
* @since 2021-11-04
*/
@RestController
@RequestMapping("/platform-audit")
@Slf4j
@Api(tags = "平台端审核表")
public class PlatformAuditController {

    @Autowired
    private PlatformAuditService platformAuditService;
    @Autowired
    private ComponentDetailService componentDetailService;


    @ApiOperation(value = "根据审核状态进行分页")
    @PostMapping(value = "/searchPlatformAuditlist",produces = "application/json;charset=UTF-8")
    public ResultBean<Page<PlatformAudit>> searchPlatformAuditlist(@ApiParam(name = "pageNum", value = "页码", required = true, defaultValue = "1")@RequestParam(name = "pageNum", defaultValue = "1") int pageNum,
                                                                   @ApiParam(name = "pageSize", value = "每页条数", required = true, defaultValue = "10")@RequestParam(name = "pageSize", defaultValue = "10") int pageSize,
                                                                   @ApiParam(name = "auditStatus", value = "审核状态：1.待审核 2.未通过 3.已通过", required = false)@RequestParam(name = "auditStatus",required = false) String auditStatus){
        return platformAuditService.searchPlatformAuditlist(pageNum,pageSize,auditStatus);
    }

    @ApiOperation(value = "修改审核状态，并且将审核通过的部件上报给城市管理系统")
    @PostMapping(value = "/updateAuditStatus",produces = "application/json;charset=UTF-8")
    public ResultBean updateAuditStatus(@ApiParam(name = "id", value = "审核id", required = true)@RequestParam(name = "id") String id,
                                        @ApiParam(name = "componentId", value = "部件id", required = true)@RequestParam(name = "componentId") String componentId,
                                        @ApiParam(name = "auditStatus", value = "审核状态: 2.未通过 3.已通过", required = true)@RequestParam("auditStatus") String auditStatus,
                                        @ApiParam(name = "componentLogo", value = "部件标识(无重复)", required = true)@RequestParam("componentLogo") String componentLogo){
        return platformAuditService.updateAuditStatus(id,componentId,auditStatus,componentLogo);
    }

    @ApiOperation(value = "获取审核详情")
    @PostMapping(value = "/selectDetailAudit",produces = "application/json;charset=UTF-8")
    public ResultBean<AuditComponentVo> selectDetailAudit(@ApiParam(name = "id", value = "审核id", required = true)@RequestParam(name = "id") String id,
                                                          @ApiParam(name = "componentDetailId", value = "部件id", required = true)@RequestParam("componentDetailId") String componentDetailId,
                                                          @ApiParam(name = "componentIssuesReportId", value = "上报案件id", required = true)@RequestParam("componentIssuesReportId") String componentIssuesReportId){
        return platformAuditService.selectDetailAudit(id,componentDetailId,componentIssuesReportId);
    }





}
