package com.hncy.service.wechat.applet.biz.entity;

import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 部件图片表
 * </p>
 *
 * @author cs
 * @since 2021-11-04
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="ComponentPicture对象", description="部件图片表")
public class ComponentPicture extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "部件图片名称")
    private String componentPictureName;

    @ApiModelProperty(value = "部件图片大小")
    private String componentPictureSize;

    @ApiModelProperty(value = "部件图片链接：相对路径")
    private String componentPictureUrl;

    @ApiModelProperty(value = "部件图片类型")
    private String componentPictureType;

    @ApiModelProperty(value = "存储形式：1.部件采集 2.问题上报")
    private String storageForm;


    public static final String COMPONENT_PICTURE_NAME = "component_picture_name";

    public static final String COMPONENT_PICTURE_SIZE = "component_picture_size";

    public static final String COMPONENT_PICTURE_URL = "component_picture_url";

    public static final String COMPONENT_PICTURE_TYPE = "component_picture_type";

    public static final String STORAGE_FORM = "storage_form";

}
