package com.hncy.service.wechat.applet.biz.entity;

import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 部件与图片关联表
 * </p>
 *
 * @author cs
 * @since 2021-11-04
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="ComponentPictureRelation对象", description="部件与图片关联表")
public class ComponentPictureRelation extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "部件id")
    private String componentDetailId;

    @ApiModelProperty(value = "部件问题id")
    private String componentIssuesReportId;

    @ApiModelProperty(value = "图片id")
    private String componentPictureId;


    public static final String COMPONENT_DETAIL_ID = "component_detail_id";

    public static final String COMPONENT_ISSUES_REPORT_ID = "component_issues_report_id";

    public static final String COMPONENT_PICTURE_ID = "component_picture_id";

}
