package com.hncy.service.wechat.applet.biz.entity;

import java.time.LocalDateTime;
import java.util.Date;

import com.hncy.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 平台端审核表
 * </p>
 *
 * @author cs
 * @since 2021-11-04
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="PlatformAudit对象", description="平台端审核表")
public class PlatformAudit extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "审核状态：1.待审核 2.未通过 3.已通过")
    private String auditStatus;

    @ApiModelProperty(value = "审核时间")
    private Date auditTime;

    @ApiModelProperty(value = "部件名字")
    private String componentName;

    @ApiModelProperty(value = "部件状态")
    private String componentStatus;

    @ApiModelProperty(value = "部件采集员")
    private String componentCollector;

    @ApiModelProperty(value = "部件采集时间")
    private Date componentCollectTime;

    @ApiModelProperty(value = "上报案件id")
    private String componentIssuesReportId;

    @ApiModelProperty(value = "部件id")
    private String componentDetailId;


    public static final String COMPONENT_ISSUES_REPORT_ID = "component_issues_report_id";

    public static final String COMPONENT_DETAIL_ID = "component_detail_id";

    public static final String AUDIT_STATUS = "audit_status";

    public static final String AUDIT_TIME = "audit_time";



}
