package com.hncy.service.wechat.applet.biz.mini.config;

import com.hncy.service.wechat.applet.biz.mini.constant.MiniProgramConstant;
import feign.Request;
import feign.codec.Decoder;
import org.springframework.beans.factory.ObjectFactory;
import org.springframework.boot.autoconfigure.http.HttpMessageConverters;
import org.springframework.cloud.openfeign.support.SpringDecoder;
import org.springframework.context.annotation.Bean;
import org.springframework.http.MediaType;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * @Author: ying.dong
 * @Date: 2021/6/15 15:33
 */
public class MiniProgramClientConfiguration {

    @Bean
    Request.Options miniProgramFeignOptions() {
        return new Request.Options(MiniProgramConstant.DEFAULT_CONNECTION_TIMEOUT, TimeUnit.SECONDS,
                MiniProgramConstant.DEFAULT_READ_TIMEOUT, TimeUnit.SECONDS, true);
    }

    @Bean
    public Decoder feignDecoder(){
        MiniProgramMessageConverter wxConverter = new MiniProgramMessageConverter();
        ObjectFactory<HttpMessageConverters> objectFactory = () -> new HttpMessageConverters(wxConverter);
        return new SpringDecoder(objectFactory);
    }

    static class MiniProgramMessageConverter extends MappingJackson2HttpMessageConverter {
        public MiniProgramMessageConverter() {
            List<MediaType> mediaTypes = new ArrayList<>();
            mediaTypes.add(MediaType.TEXT_PLAIN);
            setSupportedMediaTypes(mediaTypes);
        }
    }
}
