package com.hncy.service.wechat.applet.biz.mini.service;

import com.hncy.service.wechat.applet.api.dto.output.BaseOutput;
import com.hncy.service.wechat.applet.api.dto.output.Code2SessionOutput;
import org.springframework.lang.NonNull;
import org.springframework.lang.Nullable;

import java.util.Map;

/**
 * @Author: ying.dong
 * @Date: 2021/6/21 17:24
 */
public interface MiniProgramService {

    /**
     * 小程序登陆
     * @param code
     * @return
     */
    Code2SessionOutput login(String code);

    /**
     * 获取access_token
     * @return
     */
    String getAccessToken();

    /**
     * 发送订阅消息
     * @param openId
     * @param templateId
     * @param jsonData
     * @param page
     * @return
     */
    BaseOutput sendSubscribeMessage(@NonNull String openId, @NonNull String templateId, @NonNull Map<String, Object> jsonData,
                                    @Nullable String page, @Nullable Map<String, Object> pageParams);
}
