package com.hncy.service.wechat.applet.biz.service;

import cn.hutool.core.date.DateTime;
import com.hncy.common.dto.ResultBean;
import com.hncy.service.wechat.applet.biz.entity.ComponentIssuesReport;
import com.baomidou.mybatisplus.extension.service.IService;
import com.hncy.service.wechat.applet.biz.vo.RegTypesVo;

import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 部件问题上报 服务类
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
public interface ComponentIssuesReportService extends IService<ComponentIssuesReport> {

    /**
     * @param componentReportCode
     * @param componentReportName
     * @return
     * @Description 获取所有部件上报案件状态类型
     * @Date 2021/11/3 14:45
     */
    ResultBean<List<RegTypesVo>> selectAllRegTypes(String componentReportCode, String componentReportName);

    /**
     * @param regCondCode
     * @param regCondName
     * @param issueDescription
     * @param componentReportCode
     * @param componentReportName
     * @return
     * @Description 新增上报问题部件
     * @Date 2021/11/3 18:01
     */
    ResultBean saveComponentIssues(String regCondCode, String regCondName, String issueDescription, String componentReportCode, String componentReportName);

    /**
     * @param componentAddress
     * @param xCode
     * @param yCode
     * @param reportTime
     * @param regCondCode
     * @param regCondName
     * @param issueDescription
     * @param pictureIds
     * @param reportNickName
     * @param reportOpenId
     * @param issueNumber
     * @return
     * @Description 问题上报
     * @Date 2021/11/5 11:17
     */
    ResultBean componentReport(String componentName,
                               String componentCode,
                               String componentSuperName,
                               String componentSuperCode,
                               String componentAddress,
                               String xCode,
                               String yCode,
                               DateTime reportTime,
                               String regCondCode,
                               String regCondName,
                               String issueDescription,
                               List<String> pictureIds,
                               String reportNickName,
                               List<String> componentLogos,
                               String reportOpenId,
                               String issueNumber);

}





