package com.hncy.service.wechat.applet.biz.service;

import com.hncy.common.dto.ResultBean;
import com.hncy.service.wechat.applet.biz.entity.ComponentType;
import com.baomidou.mybatisplus.extension.service.IService;
import com.hncy.service.wechat.applet.biz.vo.ComponentSubTypesVo;
import com.hncy.service.wechat.applet.biz.vo.ComponentSupperVo;
import com.hncy.service.wechat.applet.biz.vo.ComponentTypesVo;

import java.util.List;

/**
 * <p>
 * 部件类型 服务类
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
public interface ComponentTypeService extends IService<ComponentType> {

    /**
     * @Description 获取城市部件类型以及立案条件（内部调用）
     * @Date 2021/11/2 19:54
     * @param
     * @return
     */
    ResultBean getComponentTypeAndRegCondByCtiySys();

    /**
     * @Description 下拉框获取所有部件类型
     * @Date 2021/11/3 11:22
     * @param
     * @return
     */
    ResultBean<List<ComponentTypesVo>> selectAllTypes();

    /**
     * @Description 根据部件类别查询所有部件的子类
     * @Date 2021/11/3 11:51
     * @param componentTypeName
     * @param componentTypeCode
     * @param componentSuperCode
     * @param componentSuperName
     * @return
     */
    ResultBean<List<ComponentSubTypesVo>> selectAllTypesBySub(String componentSuperName, String componentSuperCode, String componentTypeCode, String componentTypeName);

    /**
     * @Description 查询当前区域下所有父类下面的子类部件
     * @Date 2021/11/30 9:20
     * @param code
     * @param type
     * @return
     */
    ResultBean<List<ComponentSupperVo>> selectAllTypesBySupperComponents(String code, String type);
}
