package com.hncy.service.wechat.applet.biz.vo;

import cn.hutool.core.date.DateTime;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.Date;
import java.util.List;

/**
 * @Author: cs
 * @Date: 2021/11/5 16:14
 * 审核详情vo
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode
public class AuditComponentVo {

    @ApiModelProperty(value = "部件上报案件条件编码")
    private String regCondCode;

    @ApiModelProperty(value = "部件上报案件条件名称")
    private String regCondName;

    @ApiModelProperty(value = "部件上报案件描述情况")
    private String issueDescription;

    @ApiModelProperty(value = "部件父类名称：市容环境，公用设施，拓展部件")
    private String componentSuperName;

    @ApiModelProperty(value = "部件父类编码：003,001,021")
    private String componentSuperCode;

    @ApiModelProperty(value = "部件类型名称：垃圾桶，井盖")
    private String componentTypeName;

    @ApiModelProperty(value = "部件代码代码：1,2")
    private String componentTypeCode;

    @ApiModelProperty(value = "部件子类名称：如雨水井盖之类")
    private String componentName;

    @ApiModelProperty(value = "部件子类编码")
    private String componentCode;

    @ApiModelProperty(value = "部件标识")
    private String componentLogo;

    @ApiModelProperty(value = "部件详细地址")
    private String componentAddress;

    @ApiModelProperty(value = "审核状态：1.待审核 2.未通过 3.已通过")
    private String auditStatus;

    @ApiModelProperty(value = "审核时间")
    private Date auditTime;

    @ApiModelProperty(value = "上报人员")
    private String reporter;

    @ApiModelProperty(value = "上报时间")
    private Date reportTime;

    @ApiModelProperty(value = "图片路径组")
    private List<String> pictureUrls;



}
