package com.hncy.service.wechat.applet.biz.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @Author: cs
 * @Date: 2021/11/4 18:30
 * 部件子类类型VO
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode
public class ComponentSubsVo {

    @ApiModelProperty(value = "部件父类名称：市容环境，公用设施，拓展部件")
    private String componentSuperName;

    @ApiModelProperty(value = "部件父类编码：003,001,021")
    private String componentSuperCode;

    @ApiModelProperty(value = "部件子类名称：如雨水井盖之类")
    private String componentName;

    @ApiModelProperty(value = "部件子类编码")
    private String componentCode;

    @ApiModelProperty(value = "部件标识")
    private String componentLogo;

    @ApiModelProperty(value = "部件详细地址")
    private String componentAddress;

    @ApiModelProperty(value = "经度")
    private String xCode;

    @ApiModelProperty(value = "纬度")
    private String yCode;

    @ApiModelProperty(value = "巡检时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime patrolInspectionTime;

    @ApiModelProperty(value = "部件上报案件条件编码")
    private String regCondCode;

    @ApiModelProperty(value = "部件上报案件条件名称")
    private String regCondName;

    @ApiModelProperty(value = "当前扫描传入经纬度与部件经纬度误差距离")
    private String distance;

}
