package com.hncy.service.wechat.applet.biz.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @Author: cs
 * @Date: 2021/12/1 14:54
 * 搜索部件vo
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode
public class ComponentsSearchVo {

    @ApiModelProperty(value = "部件唯一标识")
    private String componentLogo;

    @ApiModelProperty(value = "部件父类名称：市容环境，公用设施，拓展部件")
    private String componentSuperName;

    @ApiModelProperty(value = "部件父类编码：003,001,021")
    private String componentSuperCode;

    @ApiModelProperty(value = "部件子类名称：如雨水井盖之类")
    private String componentName;

    @ApiModelProperty(value = "部件子类编码")
    private String componentCode;

    @ApiModelProperty(value = "部件详细地址")
    private String componentAddress;

    @ApiModelProperty(value = "经度(百度转84坐标系)")
    private String xCode;

    @ApiModelProperty(value = "纬度(百度转84坐标系)")
    private String yCode;

    @ApiModelProperty(value = "今日是否已经巡检(0:未巡检，1:已巡检)")
    private String isPatrolInspection;



}
